$ = jQuery.noConflict(); // Make sure jQuery owns $ here

/**
 * Using window.load instead of document.ready is a requirement for compatibility
 * with fluid images. If images (used as slides) have no dimensions set webkit
 * browsers will fail to properly scale the slider.
 */
var started = 0;
var pagerEl = '.cycle-pager';
var pagerAnchor = null;
var cyclePrev = null;
var cycleNext = null;
var pagerAnchor = null;
$(window).load(function() {
  cycleStart();
  $(window).resize(function() {
    cycleStart();
  });
});
function cycleStart() {
  // Remove contextual links, they mess up the cycle pager
  $('.block').has(Drupal.settings.slideshowKit.cycleInvoke).find('.contextual-links-wrapper').remove();

  if (parseInt(Drupal.settings.slideshowKit.cycleShowPager) && (started != 1)) {
    $(Drupal.settings.slideshowKit.cycleInvoke).after('<div class="wrap-cycle-pager"><ul class="cycle-pager">');
    pagerAnchor = function(idx, slide) {return '<li><a href="#">' + idx + '</a></li>';}
  }
  if (parseInt(Drupal.settings.slideshowKit.cycleImgPager) && (started != 1)) {
    pagerAnchor = function(idx, slide) {return '<li><a href="#"><img src="' + slide.src + '" width="100" height="100" /></a></li>';}
  }
  if (parseInt(Drupal.settings.slideshowKit.cyclePrevNext) && (started != 1)) {
    $(Drupal.settings.slideshowKit.cycleInvoke).after('<div class="cycle-previous"></div><div class="cycle-next"></div>');
    cyclePrev = '.cycle-previous';
    cycleNext = '.cycle-next';
  }

  if (started) {
    pagerEl = null;
  }

  /**
   * @code
   * force the slideshow to cover entire width
   */
  $(Drupal.settings.slideshowKit.cycleInvoke).width('100%');
  $(Drupal.settings.slideshowKit.cycleInvoke + '>*').width('100%').height('auto');

  $(Drupal.settings.slideshowKit.cycleInvoke).each(function() {
    $(this).cycle({
      fx:                   Drupal.settings.slideshowKit.cycleFx,
      timeout:              parseInt(Drupal.settings.slideshowKit.cycleTimeout),
      continuous:           parseInt(Drupal.settings.slideshowKit.cycleContinuous),
      speed:                parseInt(Drupal.settings.slideshowKit.cycleSpeed),
      pagerEvent:           Drupal.settings.slideshowKit.cyclePagerEvent,
      easing:               Drupal.settings.slideshowKit.cycleEasing,
      random:               parseInt(Drupal.settings.slideshowKit.cycleRandom),
      pause:                parseInt(Drupal.settings.slideshowKit.cyclePause),
      pauseOnPagerHover:    parseInt(Drupal.settings.slideshowKit.cyclePauseOnPagerHover),
      delay:                parseInt(Drupal.settings.slideshowKit.cycleDelay),
      pager:                pagerEl,
      pagerAnchorBuilder:   pagerAnchor,
      prev:                 cyclePrev,
      next:                 cycleNext,
      /**
       * @code
       * For the slides cycle has built in fitting and forced aspec-ratio
       * ...perfect for our flexible slider.
       */
      fit: 1,
      aspect: 1
    });
  });

  /**
   * @ code
   * This is required to force the browse to upscale image slides at window.resize
   * (e.g. when switching from portrait to landscape mode)
   */
  $(Drupal.settings.slideshowKit.cycleInvoke).each(function() {
    $(this).width('100%').height($(this).find('>:first-child').height());
  });

  // Keep track of restarts
  started = 1;
}